from setuptools import setup, Extension
from Cython.Build import cythonize
import numpy

extensions = [
    Extension("quickquant.models.black_scholes", ["quickquant/models/black_scholes.pyx"], 
              include_dirs=[numpy.get_include()],
              libraries=["python3.12"],
              library_dirs=["C:\\Program Files\\Python312\\libs"],
              extra_compile_args=["/O2"],
              extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.merton_model", ["quickquant/models/merton_model.pyx"], 
              include_dirs=[numpy.get_include()],
              libraries=["python3.12"],
              library_dirs=["C:\\Program Files\\Python312\\libs"],
              extra_compile_args=["/O2"],
              extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.heston_model", ["quickquant/models/heston_model.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.american_binomial", ["quickquant/models/american_binomial.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.american_trinomial", ["quickquant/models/american_trinomial.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.american_finite_difference", ["quickquant/models/american_finite_difference.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.asian_options", ["quickquant/models/asian_options.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.barrier_options", ["quickquant/models/barrier_options.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.lookback_options", ["quickquant/models/lookback_options.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.swaptions", ["quickquant/models/swaptions.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.hull_white", ["quickquant/models/hull_white.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.cir_model", ["quickquant/models/cir_model.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.vasicek_model", ["quickquant/models/vasicek_model.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.black_cox", ["quickquant/models/black_cox.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.creditmetrics", ["quickquant/models/creditmetrics.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.markowitz", ["quickquant/models/markowitz.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.black_litterman", ["quickquant/models/black_litterman.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.risk_parity", ["quickquant/models/risk_parity.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.models.kalman_filter", ["quickquant/models/kalman_filter.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.indicators.sma", ["quickquant/indicators/sma.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.indicators.ema", ["quickquant/indicators/ema.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.indicators.bollinger_bands", ["quickquant/indicators/bollinger_bands.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.indicators.rsi", ["quickquant/indicators/rsi.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.indicators.macd", ["quickquant/indicators/macd.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.indicators.stochastic", ["quickquant/indicators/stochastic.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.indicators.adx", ["quickquant/indicators/adx.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.indicators.atr", ["quickquant/indicators/atr.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.indicators.ichimoku", ["quickquant/indicators/ichimoku.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
    Extension("quickquant.indicators.volume_profile", ["quickquant/indicators/volume_profile.pyx"], 
            include_dirs=[numpy.get_include()],
            libraries=["python3.12"],
            library_dirs=["C:\\Program Files\\Python312\\libs"],
            extra_compile_args=["/O2"],
            extra_link_args=["/MANIFEST"],
    ),
]

setup(
    name="quickquant",
    version="0.2.0",
    author="Nabarup Ghosh",
    author_email="nabarupeducation@gmail.com",
    description="A fast quant finance library",
    ext_modules=cythonize(extensions),
    license="Apache License 2.0",
    packages=["quickquant", "quickquant.models", "quickquant.indicators", "quickquant.data", "quickquant.utils"],
    classifiers=[
        "Programming Language :: Python :: 3",
        "License :: OSI Approved :: Apache Software License",
        "Operating System :: OS Independent",
    ],
)
